<template>
  <div class="admin-department">
    <el-form :inline="true">
      <el-form-item v-if="$permission('/admin/position/check')">
        <el-input v-model="queryParams.name" size="small" placeholder="请输入"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="" size="small" @click="getList" v-if="$permission('/admin/position/check')">查询</el-button>
        <el-button type="primary" size="small" @click="handleAdd(0)" v-if="$permission('/admin/position/add')">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table :data="tableData" v-loading="loading"  style="width: 100%">
      <!-- <el-table-column prop="department" label="所属部门" align="center" show-overflow-tooltip></el-table-column> -->
       <el-table-column prop="position" label="职位名称" align="center" show-overflow-tooltip></el-table-column>
       <el-table-column label="角色" align="center" show-overflow-tooltip>
        <template slot-scope="scope">
          <span v-for="item in scope.row.roleList">{{item.name}}
          </span>
        </template>
       </el-table-column>
       <el-table-column  label="是否唯一" align="center" show-overflow-tooltip>
         <template slot-scope="scope">
        <span style="margin-left: 10px" v-if="scope.row.ismore==0">否</span>
        <span style="margin-left: 10px" v-if="scope.row.ismore==1">是</span>
      </template>
       </el-table-column>
      <el-table-column prop="describe" label="描述" align="center" show-overflow-tooltip></el-table-column>
      <el-table-column label="操作" align="center" width="150">
        <template slot-scope="scope">
          <el-dropdown split-button type="primary" size="small" >
          
            <span @click="handleEdit(scope.row)" v-if="$permission('/admin/position/modify')">编辑</span>
            <span v-else :disabled="true">编辑</span>
            <el-dropdown-menu slot="dropdown" class="text-align_center">
              <!-- <el-dropdown-item @click.native="handleAdd(scope.row.id)">新增</el-dropdown-item> -->
              <el-dropdown-item class="color-red" @click.native="handleDelete(scope.row)" divided v-if="$permission('/admin/position/delete')">删除</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>
      <div class="pagination">
      <el-pagination :current-page.sync="queryParams.current" :page-size="queryParams.size" :total="total" @current-change="handleCurrentChange" layout="total, prev, pager, next, jumper" background></el-pagination>
    </div>
    <el-dialog :title="title" :visible.sync="visible" width="500px" :before-close="close">
      <el-form v-if="visible" :model="ruleForm" :rules="rules" ref="ruleForm" label-width="80px" label-position="left">
        
            <el-form-item label="所属租户" prop="tenant">
              <el-tooltip
                  class="item"
                  effect="dark"
                  :disabled="!userinfo.tenantName"
                  :content="userinfo.tenantName"
                  placement="top-start"
                >
                <el-input v-model="userinfo.tenantName" placeholder="请输入所属租户" :readonly="true" ></el-input>
                </el-tooltip>
            </el-form-item>
        <!-- <el-form-item label="所属部门" prop="department">
          <treeselect
              v-model="ruleForm.department"
              :options="tableData"
              :disable-branch-nodes="false"
              :show-count="true"
              placeholder="请选择"
              :normalizer="normalizer"
          />
        </el-form-item> -->
        <el-form-item label="职位名称" prop="position">
          <el-input v-model="ruleForm.position" placeholder="请输入职位名称"></el-input>
        </el-form-item>
             <el-form-item label="角色" prop="role">
            <el-select v-model="ruleForm.role" 
            filterable
            multiple
            collapse-tags
            placeholder="请选择角色"
            style="display:block">
            <el-option
              v-for="item in roleList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
              >
            </el-option>
          </el-select>
        </el-form-item>
    <el-form-item label="是否唯一" prop="ismore">
           <el-radio-group v-model="ruleForm.ismore">
    <el-radio :label="1">是</el-radio>
    <el-radio :label="0">否</el-radio>
    
  </el-radio-group>
        </el-form-item>
        <el-form-item label="描述" prop="describe">
          <el-input v-model="ruleForm.describe" placeholder="请输入描述" type="textarea" maxlength="100" show-word-limit></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="close">取 消</el-button>
        <el-button type="primary" @click="submit" :loading="btnLoading">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'


export default {
  components: {
    Treeselect
  },
  data() {
    return {
      visible: false,
      loading: false,
      btnLoading: false,
      total: 0,
      tableData: [],
      title: '',
      roleList:[],
      queryParams: {
        size: 10,
        current: 1,
        name: ''
      },
      ruleForm: {
        ismore:0
      },
      rules: {
        department: [{ required: true, message: '请选择所属部门', trigger: 'change' },],
        position: [{ required: true, message: '请输入职位名称', trigger: 'blur' },],
        ismost: [{ required: true, message: '请选择', trigger: 'change' },],
      },
    }
  },
  mounted() {
    this.getList()
    this.getRoleList()
    // if(this.$permission('/admin/position/modify')==false){
    //   var a = document.getElementsByClassName('el-dropdown')
    //   for(var i = 1; i<a.length; i++){
        
    //   }
    // }
  },

  computed: {
    userinfo() {
      return this.$store.state.admin.userinfo
    }
  },


  methods: {
    normalizer(node) {
      return {
        id: node.id,
        label: node.name,
      }
    },
    handleAdd(parentId) {
      this.title = '新增职位'
      this.visible = true
      this.ruleForm = {
        ismore: 0
      }
    },
    handleEdit(row) {
      this.title = '编辑职位'
      this.visible = true
      this.ruleForm = { ...row }
    },
    close() {
      this.visible = false
    },
    handleCurrentChange(val) {
      this.queryParams.current = val;
      this.getList();
    },
    getList() {
      this.loading = true
      this.$api.getPositionList(this.queryParams).then(response => {
        console.log(response)
        this.tableData = response.data
        this.total = response.pageColumn.total
        this.loading = false
      }).catch(error => {
        this.loading = false
      })
    },
    getRoleList(){
      this.$api.getRoleList().then(response => {
        this.roleList = response.data
      })
    },
    submit() {
      this.$refs.ruleForm.validate((valid) => {
        if (valid) {
          this.btnLoading = true
          if (this.ruleForm.id) {
            this.$api.editPosition(this.ruleForm).then(response => {
              this.$message.success('编辑成功')
              this.btnLoading = false
              this.getList()
              this.close()
            }).catch(error => {
              this.btnLoading = false
            })
          } else {
            this.ruleForm.tenant=this.userinfo.tenantId
            this.$api.addPosition(this.ruleForm).then(response => {
              this.$message.success('新增成功')
              this.btnLoading = false
              this.getList()
              this.close()
            }).catch(error => {
              this.btnLoading = false
            })
          }
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    handleDelete(row) {
      this.$confirm('确认删除本条数据吗？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.loading = true
        this.$api.deletePosition({ id: row.id }).then(response => {
          this.$message.success('删除成功')
          this.loading = false
          this.getList()
        }).catch(error => {
          this.loading = false
        })
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.admin-department {

}
</style>